unit glmath;

interface

uses opengl12, glmatrix;

type
  //generic opengl color record (should not be here)
  TGLColor=packed record
    red,green,blue,alpha: GLclampf;
  end;

  T3dpoint     = packed record
    x, y, z        :Single;
  end;

var
   hastexture: TGLint;  

function CalcNormalVector(const Point1,Point2,Point3:T3DPoint):T3DPoint;
function MatrixTransform(matrix: clsMatrix; vertex: T3DPoint): T3DPoint;

implementation

function MatrixTransform(matrix: clsMatrix; vertex: T3DPoint): T3DPoint;
var
   tempmatrix : array [0..15] of single;

begin
  matrix.getMatrix(tempmatrix);
  result.x := vertex.x*tempmatrix[0]+vertex.y*tempmatrix[4]+vertex.z*tempmatrix[8]+tempmatrix[12];
  result.y := vertex.x*tempmatrix[1]+vertex.y*tempmatrix[5]+vertex.z*tempmatrix[9]+tempmatrix[13];
  result.z := vertex.x*tempmatrix[2]+vertex.y*tempmatrix[6]+vertex.z*tempmatrix[10]+tempmatrix[14];
end;

function CalcNormalVector(const Point1,Point2,Point3:T3DPoint):T3DPoint;
var longi:single;
    vx1,vx2,vy1,vy2,vz1,vz2:Single;
begin
  vx1:=Point1.x-Point2.x;
  vy1:=Point1.y-Point2.y;
  vz1:=Point1.z-Point2.z;
  vx2:=Point2.x-Point3.x;
  vy2:=Point2.y-Point3.y;
  vz2:=Point2.z-Point3.z;
  with Result do begin
     x:=vy1*vz2 - vz1*vy2;
     y:=vz1*vx2 - vx1*vz2;
     z:=vx1*vy2 - vy1*vx2;
     longi:=sqrt(sqr (x) + sqr(y) + sqr(z));
     If longi>0 then begin x:=x/longi; y:=y/longi; z:=z/longi; end;
  end;
  result.x:=-result.x;
  result.y:=-result.y;
  result.z:=-result.z;
end;


end.
